--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

if (UnitLevel("player") == 60) then return end
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}


local function CreateBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 6,
		insets = {top = 0, left = 0, bottom = 0, right = 0}
		})
		frame:SetBackdropColor(0.3,0.3,0.3,0.25)
		frame:SetBackdropBorderColor(0,0,0,1)
end


local function CreateButtonTexture(frame)
	local ButtonForground = CreateFrame("Frame","Foreground",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForground:SetAllPoints(frame)
		  ButtonForground:SetFrameLevel(4)
	local ButtonTexture = ButtonForground:CreateTexture(nil, "BACKGROUND")
		  ButtonTexture:SetAllPoints()
		  ButtonTexture:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		  ButtonTexture:SetTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\PsychoButton")
		
end

local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end

local XPMover = CreateFrame("Frame","InkedXPBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	XPMover:SetSize(350,24)
	XPMover:SetFrameLevel(98)
	XPMover:SetClampedToScreen(true)
	XPMover:SetClampRectInsets(0, 0, 0,0)
	
	local XPMoverText  = XPMover:CreateFontString(nil, "OVERLAY")
	XPMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	XPMoverText:SetPoint("CENTER",XPMover,"CENTER", 0,0); 
	XPMoverText:SetText("")
	
	local InkedXPBar = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedXPBar:SetAllPoints(XPMover)
	
	local XPframe = CreateFrame("Frame", nil, InkedXPBar, BackdropTemplateMixin and "BackdropTemplate")
	XPframe:SetAllPoints(InkedXPBar)
	--CreateBackdrop(XPframe)
	XPframe.bar = CreateFrame("StatusBar", nil, XPframe, BackdropTemplateMixin and "BackdropTemplate")
	XPframe.bar:SetFrameLevel(6)
	XPframe.bar:SetPoint("TOPLEFT", 2, -3)
	XPframe.bar:SetSize(342,19)
	XPframe.barR = CreateFrame("StatusBar", nil, XPframe, BackdropTemplateMixin and "BackdropTemplate")
	XPframe.barR:SetFrameLevel(5)
	XPframe.barR:SetPoint("TOPLEFT", 2, -3)
	--XPframe.barR:SetAllPoints(XPframe)
	XPframe.barR:SetSize(342,19)
	
	
	local XPText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
	XPText:SetPoint("LEFT", 2, 0)
	XPText:SetJustifyH("LEFT")
	XPText:SetJustifyV("CENTER")
	local XPMaxText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
	XPMaxText:SetPoint("RIGHT", -2, 0)
	XPMaxText:SetJustifyH("RIGHT")
	XPMaxText:SetJustifyV("CENTER")
	local XPRestedText = XPframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
	XPRestedText:SetPoint("CENTER", 0, 0)
	XPRestedText:SetJustifyH("CENTER")
	XPRestedText:SetJustifyV("CENTER")
	
function truncate(number, decimals)
    return number - (number % (0.1 ^ decimals))
end

local function UpdateMe()
		if(Inked.db.profile.lockframes == false) then
			if Inked.db.profile.XPEnable == true then
				local point, relativeTo, relativePoint, xOfs, yOfs = XPMover:GetPoint(n)
				Inked.db.profile.XPX = xOfs
				Inked.db.profile.XPY = yOfs
				Inked.db.profile.XPPoint = point
				XPMoverText:SetText("XP BAR")
			end
		end	
		if Inked.db.profile.XPEnable == true then
			XPMover:SetSize(Inked.db.profile.XPWidth,Inked.db.profile.XPHeight)
			XPframe.bar:SetSize(Inked.db.profile.XPWidth-4,Inked.db.profile.XPHeight-5)
			XPframe.barR:SetSize(Inked.db.profile.XPWidth-4,Inked.db.profile.XPHeight-5)			
			
		--	(LSM:Fetch("font", Inked.db.profile.XPfont), Inked.db.profile.XPFontSize,Inked.db.profile.XPFontOutline)	
			XPText:SetFont(LSM:Fetch("font", Inked.db.profile.XPfont), Inked.db.profile.XPFontSize,Inked.db.profile.XPFontOutline)
			XPMaxText:SetFont(LSM:Fetch("font", Inked.db.profile.XPfont), Inked.db.profile.XPFontSize,Inked.db.profile.XPFontOutline)
			XPRestedText:SetFont(LSM:Fetch("font", Inked.db.profile.XPfont), Inked.db.profile.XPFontSize,Inked.db.profile.XPFontOutline)
			XPframe.bar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.XPStatusBar))
			XPframe.bar:SetStatusBarColor(.41,.60,.95)
			XPframe.barR:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.XPStatusBar))
			XPframe.barR:SetStatusBarColor(.6,.2,.8,1)
			
			XPframe.bar:SetMinMaxValues(0, UnitXPMax("player"))
			XPframe.bar:SetValue(UnitXP("player"))	
			local inBattle = C_PetBattles.IsInBattle()
			--print(inBattle)
				if(inBattle == true) then
				XPframe:Hide()
				elseif (inBattle == false) then
				XPframe:Show()	
				end
			local rested = GetXPExhaustion()
			if rested ~= nil then		
				local restedPerc = math.floor(rested / UnitXPMax("player") * 100 + 0.5)	
				if UnitXP("player") > 1000 then
					XPText:SetText(truncate(UnitXP("player")/1000,1).."K")
				else
					XPText:SetText(UnitXP("player"))
				end
				--XPText:SetText(UnitXP("player"))	
				if UnitXPMax("player") > 1000 then
					XPMaxText:SetText(truncate(UnitXPMax("player")/1000,1).."K")
				else
					XPMaxText:SetText(UnitXPMax("player"))
				end				
				--XPMaxText:SetText(UnitXPMax("player"))		
				XPRestedText:SetText(restedPerc.."% Rested")			
				XPframe.barR:SetMinMaxValues(0, UnitXPMax("player"))
				XPframe.barR:SetValue(UnitXP("player")+rested)
			end
			if rested == nil then
				--XPText:SetText(UnitXP("player"))
				if UnitXP("player") > 1000 then
					XPText:SetText(truncate(UnitXP("player")/1000,1).."K")
				else
					XPText:SetText(UnitXP("player"))
				end
			--	XPMaxText:SetText(UnitXPMax("player"))
			if UnitXPMax("player") > 1000 then
					XPMaxText:SetText(truncate(UnitXPMax("player")/1000,1).."K")
				else
					XPMaxText:SetText(UnitXPMax("player"))
				end		
				XPRestedText:SetText("")
				XPframe.barR:SetStatusBarColor(0,0,0,0)
			end
		end
end	
	---Update Database check
	local AnimeSettingsFrame = CreateFrame("Frame")	
	AnimeSettingsFrame:HookScript("OnUpdate",UpdateMe)
	

local function SetXPBar()
if Inked.db.profile.XPEnable == true then
	CreateBackdrop(XPframe.bar)
end	
	if(Inked.db.profile.lockframes == false) then
			XPMover:ClearAllPoints()
			if Inked.db.profile.XPPoint == nil then
				XPMover:SetPoint("TOP", UIParent,Inked.db.profile.XPX,Inked.db.profile.XPY)
			else
				XPMover:SetPoint(Inked.db.profile.XPPoint, UIParent,Inked.db.profile.XPX,Inked.db.profile.XPY)
			end
			if Inked.db.profile.XPEnable == true then
				CreateMoverBackdrop(XPMover)
				XPMover:SetMovable(true)
				XPMover:EnableMouse(true)
				XPMover:RegisterForDrag("LeftButton")
				XPMover:SetScript("OnDragStart", XPMover.StartMoving)
				XPMover:SetScript("OnDragStop", XPMover.StopMovingOrSizing)
				XPMover:SetUserPlaced(true)
			end
		elseif Inked.db.profile.XPPoint == nil then
				XPMover:SetPoint("TOP", UIParent,Inked.db.profile.XPX,Inked.db.profile.XPY)
			else
				XPMover:SetPoint(Inked.db.profile.XPPoint, UIParent,Inked.db.profile.XPX,Inked.db.profile.XPY)
		end

end
local function walkingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == false) then
	XPframe:Show()
		--print("walking")
	end
end
local function ridingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == true) then
	XPframe:Hide()
	end
end
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()

	if(inBattle == true) then
	
	XPframe:Hide()
	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
--print(inBattle)
	if(inBattle == false) then
	XPframe:Show()
		
	end
end
	local function OnEvent(self)
		
		self:SetScript("OnEnter", function()
			
			local rested = GetXPExhaustion()
			
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()

			GameTooltip:AddDoubleLine("Experience")
			GameTooltip:AddLine(" ")
			GameTooltip:AddDoubleLine(UnitXP("player") .. "  /  " .. UnitXPMax("player"))
			if rested ~= nil then		
				local restedPerc = math.floor(rested / UnitXPMax("player") * 100 + 0.5)
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(restedPerc .. "% : Rested XP")
			end
			GameTooltip:Show()
		end)		
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		end

		XPframe:SetScript("OnEvent", OnEvent)
		XPframe:HookScript("OnUpdate", OnEvent)

	local InkedLoginFrame=CreateFrame("Frame") -- Create the Frame
	InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")--Register the Player Login event
	InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
	InkedLoginFrame:RegisterEvent("PET_BATTLE_OPENING_START")
	InkedLoginFrame:RegisterEvent("PET_BATTLE_CLOSE")
	InkedLoginFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
	InkedLoginFrame:RegisterEvent("UNIT_ENTERED_VEHICLE")
	InkedLoginFrame:SetScript("OnEvent", function(self, event) -- create the event script	
		if Inked.db.profile.UseActionBars == false then return end	
		if Inked.db.profile.XPEnable == false then return end	
			SetXPBar()
			StartBattlePetsFun()
			EndBattlePetsFun()
			ridingFun()
			walkingFun()
		end)--make sure we close the event scri

